#include "Sellers.h"

Sellers::Sellers(bool countOnly, const char* pattern, size_t m, int error): ApproximateMatcher(countOnly){
	this-> m = m;
	this-> pattern = pattern;
	this-> error = error;
	n = 0;
	columns[0] = new int[m+1];
	columns[1] = new int[m+1];
	
	resetOnLineBreak();
}

void Sellers::resetOnLineBreak() {
	currentColumn = 1;

	//Caso base da programação dinâmica
	for(int i = 0; i <= m; ++i)
		columns[0][i] = i;
	columns[1][0] = 0;
}

int Sellers::update(char* chunk, size_t chunkSize){
	int initialPos = (n==0) ? 0 : (m+error-1);

	for(int i = initialPos; i < chunkSize; ++i) {
		if(chunk[i] != '\n') {
			for(int j = 1; j <= m; ++j){
				int phi = (pattern[j-1] == chunk[i]) ? 0 : 1;

				columns[currentColumn][j] = 
				MIN(
					1 + MIN(columns[1^currentColumn][j], columns[currentColumn][j-1]),
					phi + columns[1^currentColumn][j-1]);
			}

			if(columns[currentColumn][m] <= error) {
				registerAMatching(chunk, i, m, error);
			}

			currentColumn ^= 1;
		} else {
			//recomeça casamento no final da linha
			resetOnLineBreak();
		}
		++n;
	}

	return m+error-1;
}
