#ifndef SELLERS
#define SELLERS

#include "ApproximateMatcher.h"

class Sellers : public ApproximateMatcher {
public:
	Sellers(bool countOnly, const char* pattern, size_t m, int error);

	//Ver Matcher::update
	int update(char* chunk, size_t chunkSize);

	const char* getAlgoName(){
		return "Sellers";
	}

	void resetForNewFile() {
		n = 0;
		resetOnLineBreak();
		numberOfMatchings = 0;
	}

private:
	const char* pattern; //O padrão
	size_t m; //O tamanho do padrão

	size_t n;//O tamanho do texto recebido até agora

	int error;//O erro máximo permitido

	int* columns[2]; //As duas últimas colunas da PD

	int currentColumn;//A coluna atual (a ser preenchida)

	//Zera o estado do algoritmo para evitar que o caracter '\n' seja tratado como parte do texto
	void resetOnLineBreak();
};

#endif