#include "WuMamber2.h"

WuMamber2::WuMamber2(bool countOnly, const char* pattern, size_t m, int error): ApproximateMatcher(countOnly),
	ALL_BITS_SET(-ONE) {

	this -> pattern = pattern;
	this -> m = m;
	n = 0;
	this -> error = error;

	msb = ONE << (m-1);

	S = new ull[error+1];
	
	resetOnLineBreak();

	buildCharMasks();
}

void WuMamber2::resetOnLineBreak() {
	//caso base
	S[0] = ALL_BITS_SET;
	for(int q = 1; q <= error; ++q)
		S[q] = S[q-1] << 1;
}

//Igual ao ShiftOr
void WuMamber2::buildCharMasks() {
	memset(C, -1, sizeof C);

	ull posMask = ~ONE;

	for(int i = 0; i < m; ++i) {
		C[ALPHABET_INDEX(pattern[i])] &= posMask;
		posMask = (posMask << 1) | ONE;
	}
}

int WuMamber2::update(char* chunk, size_t chunkSize) {
	int initialPos = (n==0) ? 0 : (m+error-1);

	for(int i = initialPos; i < chunkSize; ++i) {
		if(chunk[i] != '\n') {
			ull sTmp = S[0];
			S[0] = (S[0] << 1) | C[ALPHABET_INDEX(chunk[i])]; //0 erros: igual ao ShiftOr

			for(int q = 1; q <= error; ++q) {
				ull sTmp2 = S[q];

				S[q] = 
					((S[q] << 1) | C[ALPHABET_INDEX(chunk[i])]) & //a* -> Caso em que ocorre matching
					(sTmp << 1) & //b* -> Caso em que ocorre mismatch
					(S[q-1] << 1) & //c* -> Remoção no padrão
					sTmp; //d* -> Insersão no padrão

				sTmp = sTmp2;
			}

			if(!(S[error] & msb)) {
				registerAMatching(chunk, i, m, error);
			}
		} else {
			//recomeça o casamento no fim da linha
			resetOnLineBreak();
		}

		++n;

	}

	return m+error-1;
}