#ifndef WU_MAMBER2
#define WU_MAMBER2

#include "ApproximateMatcher.h"

class WuMamber2 : public ApproximateMatcher {
public:
	WuMamber2(bool countOnly, const char* pattern, size_t m, int error);

	//Ver Matcher::update
	int update(char* chunk, size_t chunkSize);

	const char* getAlgoName() {
		return "WuMamber";
	}

	void resetForNewFile() {
		n = 0;
		resetOnLineBreak();
		numberOfMatchings = 0;
	}

private:
	const ull ALL_BITS_SET;

	//As máscaras relativas a cada letra do alfabeto e suas ocorrências no padrão
	ull C[MAX_ALPHABET_SIZE];

	ull* S; //O array com as máscaras do casamento atual
	
	ull msb; // (2^m-1): o último bit da máscara pertencente ao padrão

	const char* pattern;
	size_t m; //O tamanho do pdrão

	int error;

	size_t n; //O tamanho do texto apresentado até agora

	void buildCharMasks();

	//Zera o estado do algoritmo para evitar que o caracter '\n' seja tratado como parte do texto
	void resetOnLineBreak();
};

#endif