#include "Global.h"

int coloredPrinting = -1;

int isColoredPrintingEnabled() {
	if(coloredPrinting == -1) {
		coloredPrinting = isatty(fileno(stdout));
	}

	return coloredPrinting;
}

namespace Alphabet {
	int mapping[MAX_ALPHABET_SIZE];
	int size = -1;

	void setup(const char* pattern, size_t m) {
		/*
		 * O alfabeto já começa com o caracter nulo
		 * e todo caracter ASCII é mapeado para ele.
		 */
		memset(mapping, 0, sizeof mapping);
		size = 1;

		for(int i = 0; i < m; ++i) {
			if(mapping[ALPHABET_CONVERT(pattern[i])] == 0) 
				mapping[ALPHABET_CONVERT(pattern[i])] = size++;
		}
	}

	void incrementalSetup(const char* pattern, size_t m) {
		if(size == -1) {
			/*
		     * O alfabeto já começa com o caracter nulo
		     * e todo caracter ASCII é mapeado para ele.
		     */
			memset(mapping, 0, sizeof mapping);
			size = 1;
		}

		for(int i = 0; i < m; ++i) {
			if(mapping[ALPHABET_CONVERT(pattern[i])] == 0) 
				mapping[ALPHABET_CONVERT(pattern[i])] = size++;
		}
	}
};