#ifndef MATCHER
#define MATCHER

#include "Global.h"

class Matcher {
public:
	/*
	 * Atualiza o estado do algoritmo apresentando um 'chunk' de tamanho 'chunkSize' do texto.
	 * O algoritmo retorna o tamanho do sufixo desse chunk que deve aparecer como prefixo do
	 * próximo chunk. Isso serve para que os algoritmos tenham acesso a uma quantidade mínima
	 * dos caracteres mais recentes do texto, que podem ficar em chunks diferentes.
	 * Por exemplo, o Boyer Moore precisa de uma janela de tamanho 'm' e ela pode acabar sendo
	 * dividida em dois chunks. Outra utilidade desse retorno é a impressão das ocorrências,
	 * como no SellersRec, onde o alinhamento é reconstruído e, para isso, o algoritmo precisa dos
	 * últimos m+error caracteres do texto.
	 */
	virtual int update(char* chunk, size_t chunkSize) = 0;
	virtual ull getNumberOfMatchings() = 0;
	virtual const char* getAlgoName() = 0;
	virtual void resetForNewFile() = 0;
};

#endif

