#include "MyBinaryInteger.h"

MyBinaryInteger::MyBinaryInteger(){}

MyBinaryInteger::~MyBinaryInteger(){
	delete [] words;
}

MyBinaryInteger::MyBinaryInteger(int sizeInBits){
	setup(sizeInBits);
}

void MyBinaryInteger::setup(int sizeInBits) {
	wordCount = (sizeInBits + WORD_SIZE - 1) / WORD_SIZE;

	words = new ull[wordCount];
	turnEveryBitOn();

	lastBit = ONE << ((sizeInBits % WORD_SIZE) - 1);
}

MyBinaryInteger& MyBinaryInteger::bitwiseOr(MyBinaryInteger& other){
	for(int i = 0; i < wordCount; ++i) 
		words[i] |= other.words[i];

	return *this;
}

MyBinaryInteger& MyBinaryInteger::bitwiseAnd(MyBinaryInteger& other) {
	for(int i = 0; i < wordCount; ++i)
		words[i] &= other.words[i];

	return *this;
}

MyBinaryInteger& MyBinaryInteger::bitwiseAndAfterOneShift(MyBinaryInteger& other) {
	ull last = 0;

	for(int i = 0; i < wordCount; ++i) {
		words[i] &= (other.words[i] << 1) | last;
		last = other.words[i] >> (WORD_SIZE-1);
	}

	return *this;
}

MyBinaryInteger& MyBinaryInteger::oneShiftLeft() {
	for(int i = wordCount - 1; i > 0; --i) {
		words[i] <<= 1;
		words[i] |= words[i-1] >> (WORD_SIZE-1);
	}
	words[0] <<= 1;

	return *this;
}

MyBinaryInteger& MyBinaryInteger::turnOffLSB() {
	words[0] = (words[0] & ~ONE);

	return *this;
}

MyBinaryInteger& MyBinaryInteger::turnOnLSB() {
	words[0] = (words[0] | ONE);

	return *this;
}

bool MyBinaryInteger::getMSB() {
	return (words[wordCount-1] & lastBit) != 0;
}

MyBinaryInteger& MyBinaryInteger::turnEveryBitOn() {
	for(int i = 0; i < wordCount; ++i) 
		words[i] = -ONE;

	return *this;
}

void MyBinaryInteger::makeEqualsTo(MyBinaryInteger& other) {
	for (int i = 0; i < wordCount; ++i)
		words[i] = other.words[i];
}