#ifndef MY_BINARY_INTEGER
#define MY_BINARY_INTEGER

#include "Global.h"

class MyBinaryInteger {
public:
	static const int WORD_SIZE = 64;

	MyBinaryInteger();
	MyBinaryInteger(int sizeInBits);

	~MyBinaryInteger();
	
	void setup(int sizeInBits);

	MyBinaryInteger& bitwiseOr(MyBinaryInteger& other);
	MyBinaryInteger& bitwiseAnd(MyBinaryInteger& other);

	//faz: this = this & (other << 1)
	MyBinaryInteger& bitwiseAndAfterOneShift(MyBinaryInteger& other);

	MyBinaryInteger& oneShiftLeft();
	MyBinaryInteger& turnOffLSB();
	MyBinaryInteger& turnOnLSB();

	bool getMSB();

	MyBinaryInteger& turnEveryBitOn();

	//faz this = other
	void makeEqualsTo(MyBinaryInteger& other);
	
	ull* words;
	int wordCount;

private:
	ull lastBit;

};
#endif