#ifndef AHO
#define AHO

#include "Global.h"
#include "AutomatonNode.h"
#include "Matcher.h"

#include <vector>
using std::vector;

class Aho : public Matcher {
public:
	Aho(bool countOnly, const vector<const char*>& patterns);

	//Ver Matcher::update
	int update(char* chunk, size_t chunkSize);
	
	ull getNumberOfMatchings();

	const char* getAlgoName() {
		return "AhoCorasick";
	}

	void resetForNewFile() {
		numberOfMatchings =  n = 0;
		currentNode = root;
	}
private:
	vector<AutomatonNode> automaton; //Os nós do autômato

	int root; //O nó inicial do autômato
	int currentNode; //O nó do autômato alcançado através do texto apresentado até agora

	size_t n; //O tamanho do texto apresentado até agora

	int biggestPattern; //O tamanho do maior padrão representado no autômato

	bool countOnly; //Apenas contar as ocorrências ou também imprimí-las

	ull numberOfMatchings; // A quantidade de ocorrências encontradas até agora

	void addPattern(const char* pattern); //Adiciona um padrão ao autômato
	void buildFailureLinks(); //Inicializa a função de falha dos nós do autômato

	/*
	 * Registra que houve ocorrências dos padrões em 'listOfPatterns' terminada
	 * na posição 'matchingPos' do 'chunk' atual. Se 'countOnly = true', então
	 * cada padrão é impresso.
	 */
	void registerAMatching(char* chunk, int matchingPos, AhoList* listOfPatterns); 
};

#endif
