#ifndef BOYER_MOORE
#define BOYER_MOORE

#include "ExactMatcher.h"

class BoyerMoore : public ExactMatcher {
public:
	BoyerMoore(bool countOnly, const char* pattern, size_t m);
	
	//Ver Matcher::update
	int update(char* chunk, size_t chunkSize);

	const char* getAlgoName() {
		return "BoyerMoore";
	}

	void resetForNewFile() {
		n = 0;
		charsFromPreviousChunk = 0;
		numberOfMatchings = 0;
	}
	
	int* S; //Saldo da heurística do bom sufixo
private:
	int* C; //Heurística do mau caracter

	const char* pattern; //O padrão
	size_t m; //Tamanho do padrão

	size_t n; //Quantidade total de caracteres do texto já processados.

	//A quantidade de caracteres do último chunk que devem ser repetidos no próximo.
	int charsFromPreviousChunk;

	void setupGoodSuffix();
	void buildReversedBorder(int* borders);
	void setupBadChar();
};

#endif