#ifndef KMP
#define KMP

#include "ExactMatcher.h"

class Kmp : public ExactMatcher {
public:
	Kmp(bool countOnly, const char* pattern, size_t m);

	//Ver Matcher::update
	int update(char* chunk, size_t chunkSize);

	const char* getAlgoName(){
		return "Kmp";
	}

	void resetForNewFile() {
		n = 0;
		numberOfMatchings = 0;
	}

private:
	const char* pattern; //O padrão
	size_t m; //O tamanho do padrão

	size_t n; //O tamanho (atual) do texto

	int* fail; //A função de falha
	int p; //Ponteiro para o último prefixo casado do padrão. O prefixo vazio é -1.

	void buildFailureFunction();
};

#endif