#include "ShiftOr.h"

ShiftOr::ShiftOr(bool countOnly, const char* pattern, size_t m) : ExactMatcher(countOnly){
	this->pattern = pattern;
	this->m = m;

	C = new MyBinaryInteger[ALPHABET_SIZE];
	S.setup(m);

	n = 0;
	
	buildCharMasks();
}

void ShiftOr::buildCharMasks() {
	for(int i = 0; i < ALPHABET_SIZE; ++i) 
		C[i].setup(m);

	MyBinaryInteger posMask(m);
	posMask.turnOffLSB();

	for(int i = 0; i < m; ++i) {
		C[ALPHABET_INDEX(pattern[i])].bitwiseAnd(posMask);
		posMask.oneShiftLeft().turnOnLSB();
	}
}

//Recebe o próximo caracter do texto
int ShiftOr::update(char* chunk, size_t chunkSize) {
	int initialPosition = (n == 0) ? 0 : (m-1);

	for(int c = initialPosition; c < chunkSize; ++c) {

		char nextCharFromText = chunk[c];

		S.oneShiftLeft().bitwiseOr(C[ALPHABET_INDEX(nextCharFromText)]);

		if(!S.getMSB()) {
			registerAMatching(chunk, c, m);
		}
	}
	n += chunkSize - initialPosition;

	return m-1;
}
