#include "ShiftOr2.h"

ShiftOr2::ShiftOr2(bool countOnly, const char* pattern, size_t m) : ExactMatcher(countOnly), ALL_BITS_SET(-ONE){
	this->pattern = pattern;
	this->m = m;
	msb = ONE << (m-1);
	S = ALL_BITS_SET;
	n = 0;

	buildCharMasks();
}

void ShiftOr2::buildCharMasks() {
	memset(C, -1, sizeof C);

	ull posMask = ~1;

	for(int i = 0; i < m; ++i) {
		C[ALPHABET_INDEX(pattern[i])] &= posMask;
		posMask = (posMask << 1) | ONE;
	}
}

int ShiftOr2::update(char* chunk, size_t chunkSize) {
	int initialPosition = (n == 0) ? 0 : (m-1);

	for(int c = initialPosition; c < chunkSize; ++c) {
		S = (S << 1) | C[ALPHABET_INDEX(chunk[c])];

		if(!(S & msb)) {
			registerAMatching(chunk, c, m);
		}
	}
	
	n += chunkSize - initialPosition;

	return m-1;
}


