#ifndef SHIFT_OR_2
#define SHIFT_OR_2

#include "ExactMatcher.h"

class ShiftOr2 : public ExactMatcher {
public:
	ShiftOr2(bool countOnly, const char* pattern, size_t m);

	//Ver Matcher::update
	int update(char* chunk, size_t chunkSize);

	const char* getAlgoName(){
		return "ShiftOr2";
	}
	void resetForNewFile() {
		n = 0;
		S = ALL_BITS_SET;
		numberOfMatchings = 0;
	}

private:
	const ull ALL_BITS_SET;
	
	//As máscaras relativas a cada letra do alfabeto e suas ocorrências no padrão
	ull C[MAX_ALPHABET_SIZE];

	const char* pattern;
	size_t m;// O tamanho do padrão

	ull msb; //2^(m-1), o último bit da cadeia representando o padrão

	//O máscara do casamento atual
	ull S;

	//O tamanho do texto recebido até agora
	size_t n;
	
	void buildCharMasks();
};

#endif